//==============================================================
// TEh֘A
//--------------------------------------------------------------
// ʉǂݍ݁AAvŗpo悤ɂ܂B
//--------------------------------------------------------------

#include <stdio.h>
#include <malloc.h>
#include <string.h>
#include <pspkernel.h>
#include <pspaudiolib.h>
#include <pspiofilemgr.h>

#include "FreezeViewer.h"
#include "sound.h"

//----- 萔ݒ -----

#define SOUNDFOLDER		"sound/"								// SEt@CtH_
#define MIXCHANNEL		(5)										// 

//----- SEf[^ -----

typedef struct {												// SEf[^Ǘp
	u32		*pData;
	u32		count;
} strSE;

static strSE	gSE[eSE_count];									// SEf[^

//----- Đf[^ -----

typedef struct {
	volatile u32	*pData;										// ݍĐĂ鉹f[^ւ̃|C^
	volatile u32	count;										// cTv
} strPData;

static strPData		gPData[MIXCHANNEL];							// Đ̉f[^Ǘp

struct wavUnit {
	s16		l;
	s16		r;
};
union wavs {
	struct wavUnit	lr;
	u32				wav;
};

int		gSE_vol;												// SẺ


//==============================================================
// SE̒~
//--------------------------------------------------------------

static void se_stop(void)
{
	int		i;

	for (i = 0; i < MIXCHANNEL; i++) {
		gPData[i].pData = NULL;
		gPData[i].count = 0;
	}
}


//==============================================================
// SE̎w
//--------------------------------------------------------------
// ĐSEw肵܂B
// w肵uԂSE̍Đn܂܂B
// 𒴂SEoƂꍇ͉o܂B
//--------------------------------------------------------------

void sound_play(enum eSE SEno)
{
	int		i;

	for (i = 0; i < MIXCHANNEL; i++) {
		if (gPData[i].pData == NULL) {
			gPData[i].pData = gSE[SEno].pData;
			gPData[i].count = gSE[SEno].count;
			break;
		}
	}
}


//==============================================================
// C
//--------------------------------------------------------------

static void audioCallback(void *buf, unsigned int length, void *userdata)
{
	union wavs	wavS, wavD;
	u32		i, j, *pbuf;
	s32		data;

	pbuf = (u32*)buf;
	for (i = 0; i < length; i++) {
		pbuf[i] = 0;
	}
	for (j = 0; j < MIXCHANNEL; j++){
		for (i = 0; i < length; i++) {
			if (gPData[j].pData != NULL) {
				wavD.wav = pbuf[i];
				wavS.wav = *gPData[j].pData++;
				data = wavD.lr.l;
				data += wavS.lr.l;
				if (data >  32767) data = 32767;
				if (data < -32767) data = -32767;
				wavD.lr.l = (s16)data;							// L~bNX
				data = wavD.lr.r;
				data += wavS.lr.r;
				if (data >  32767) data = 32767;
				if (data < -32767) data = -32767;
				wavD.lr.r = (s16)data;							// R~bNX
				pbuf[i] = wavD.wav;
				gPData[j].count--;
				if (gPData[j].count == 0) {
					gPData[j].pData = NULL;
				}
			}
		}
	}
	if (gSE_vol < 0) gSE_vol = 0;
	if (gSE_vol > 100) gSE_vol = 100;
	for (i = 0; i < length; i++) {
		wavD.wav = pbuf[i];
		wavD.lr.l *= (float)gSE_vol / 100;
		wavD.lr.r *= (float)gSE_vol / 100;
		pbuf[i] = wavD.wav;
	}
}


//==============================================================
// wavt@Cǂݍ
//--------------------------------------------------------------
// vol   Fʕ␳i0  ` 100 j
// ߂lF1  ǂݍݐ
//         <0 G[
//--------------------------------------------------------------
// wavt@CĐp`ɕϊēǂݍ݂܂B
// t@C̓jAPCMɂ̂ݑΉB
//--------------------------------------------------------------

static int wavLoad(strSE *SE, char *path, int vol)
{
	SceUID		fd;
	float		step;
	u8			*p, *buf;
	s16			*tmp, waveL, waveR;
	u16			tag, channels, bits, block;
	u32			size, sps, count, pos;

	SE->pData = NULL;
	SE->count = 0;
	if (vol < 0) vol = 0;
	if (vol > 100) vol = 100;

	//----- Ώۃt@Cǂݍ -----

	fd = sceIoOpen( path, PSP_O_RDONLY, 0777 );
	if (fd < 0) {
		return -1;													// t@CJȂ
	}
	size = sceIoLseek( fd, 0, SEEK_END );
	sceIoLseek( fd, 0, SEEK_SET );
	buf = (u8*)malloc( size );
	if (buf == NULL) {
		return -2;													// mۂɎs
	}
	sceIoRead( fd, buf, size );
	sceIoClose( fd );

	//----- t@C -----

	if (size<20 || strncmp( (char*)&buf[0], "RIFF", 4 )!=0 || strncmp( (char*)&buf[8], "WAVE", 4 )!=0) {
		free( buf );
		return -3;													// wavt@Cł͂Ȃ
	}
	tag = buf[20] + buf[21] * 0x100;
	channels = buf[22] + buf[23] * 0x100;
	sps = buf[24] + buf[25] * 0x100 + buf[26] * 0x10000 + buf[27] * 0x1000000;
	block = buf[32] + buf[33] * 0x100;
	bits = buf[34] + buf[35] * 0x100;
	if (tag != 1) {												// jAPCMł͂ȂȂ
		free( buf );
		return -4;												// ΉtH[}bg
	}

	p = buf;
	size = 200;													// ʂȂ炱͈͓̔ɂ'data'`N͂
	while (size > 0) {
		if (*p == 'd') {
			if (*(p+1) == 'a' && *(p+2) == 't' && *(p+3) == 'a') {
				break;
			}
		}
		p++;
		size--;
	}
	if (size == 0) {
		free( buf );
		return -5;												// tH[}bg
	}
	size = p[4] + p[5] * 0x100 + p[6] * 0x10000 + p[7] * 0x1000000;
	p += 8;														// g`f[^
	count = size;												// g`f[^TCY
	count *= 44100.0f / sps * 4 / block;						// Đp`ɕϊɕϊ̃TCY
	tmp = (s16*)malloc( count );
	if (tmp == NULL) {
		free( buf );
		return -6;												// ̊mۂɎs
	}

	//----- g`f[^Đp`ɕϊ -----

	SE->pData = (u32*)tmp;
	pos = 0;
	step = 0;
	while (pos < size) {
		if (bits == 8) {										// 8bit
			if (channels == 1) {								// m
				waveL = p[pos] - 128;
				waveR = waveL;
			} else {											// XeI
				waveL = p[pos] - 128;
				waveR = p[pos+1] - 128;
			}
		} else {												// 16bit
			if (channels == 1) {								// m
				waveL = p[pos] + p[pos+1] * 0x100;
				waveR = waveL;
			} else {											// XeI
				waveL = p[pos  ] + p[pos+1] * 0x100;
				waveR = p[pos+2] + p[pos+3] * 0x100;
			}
		}
		*tmp++ = waveL * vol / 100;
		*tmp++ = waveR * vol / 100;
		SE->count++;
		step += (float)sps / 44100;								// ȈՃTvOgϊ
		while (step >= 1) {
			pos += block;
			step--;
		}
	}

	free( buf );
	return 1;
}

//==============================================================
// ZbgAbv
//--------------------------------------------------------------
// `l0SEpƂĎgp܂B
//--------------------------------------------------------------

int sound_setup(void)
{
	int		err;

	se_stop();
	gSE_vol = 100;

	pspAudioInit();
	pspAudioSetVolume( 0, PSP_VOLUME_MAX, PSP_VOLUME_MAX );
	pspAudioSetChannelCallback( 0, audioCallback, NULL );

	err = 1;
	err *= wavLoad( &gSE[eSE_MOVE], SOUNDFOLDER "move.wav", 100 );
	err *= wavLoad( &gSE[eSE_BACK], SOUNDFOLDER "back.wav", 100 );
	err *= wavLoad( &gSE[eSE_OPEN], SOUNDFOLDER "open.wav", 100 );
	err *= wavLoad( &gSE[eSE_BELL], SOUNDFOLDER "bell.wav", 100 );

	return err;
}


//==============================================================
// I
//--------------------------------------------------------------
// ǂݍ񂾉t@Cf[^܂B
//--------------------------------------------------------------

void sound_free(void)
{
	int		i;

	se_stop();

	for (i = 0; i < eSE_count; i++ ) {
		free( gSE[i].pData );
	}
}

