#ifndef _RAR_STRLIST_
#define _RAR_STRLIST_

#include "array.hpp"
#include "rartypes.hpp"

class StringList
{
  private:
    Array<char> StringData;
    unsigned int CurPos;

    Array<wchar> StringDataW;
    unsigned int CurPosW;

    Array<int> PosDataW;
    uint PosDataItem;

    uint StringsCount;

    uint SaveCurPos[16],SaveCurPosW[16],SavePosDataItem[16],SavePosNumber;
    bool GetStringB(char *Str, int MaxLength);
  public:
    StringList();
    ~StringList();
    void Reset();
    unsigned int AddString(const char *Str);
    char* GetStringA();
    bool GetStringC(char *Str, int MaxLength, int StringNum);
    bool GetStringD(char **Str, wchar **StrW);
    void Rewind();
    unsigned int ItemsCount() {return(StringsCount);};
    void SavePosition();
    void RestorePosition();
};

#endif
